routes/web.php
<?php

Route::get('/', 'HomeController@index')->name('/');

Auth::routes();

//ACL==================================================================================================
Route::get('user/{user}/roles', 'UserController@roles')->name('user.roles')->middleware(['auth','role:Administrador']);
Route::put('user/{user}/roles', 'UserController@rolesSync')->name('user.roles')->middleware(['auth','role:Administrador']);

Route::resource('user', 'UserController');//->middleware(['auth','role:Administrador']);

Route::get('role/{role}/permissions', 'RoleController@permissions')->name('role.permissions')->middleware(['auth','role:Administrador']);
Route::put('role/{role}/permissions', 'RoleController@permissionsSync')->name('role.permissions')->middleware(['auth','role:Administrador']);
Route::resource('role', 'RoleController')->middleware(['auth','role:Administrador']);

Route::resource('permission', 'PermissionController')->middleware(['auth','role:Administrador']);
//======================================================================================================
Route::resource('produto', 'ProdutoController')->middleware(['auth','role:Administrador']);
Route::resource('categoria', 'CategoriaController')->middleware(['auth','role:Administrador']);

Route::get('/carrinho', 'CarrinhoController@index')->name('carrinho.index')->middleware('auth');
Route::get('/carrinho/adicionar', function() {
    return redirect()->route('/');
});
Route::post('/carrinho/adicionar', 'CarrinhoController@adicionar')->name('carrinho.adicionar')->middleware('auth');
Route::delete('/carrinho/remover', 'CarrinhoController@remover')->name('carrinho.remover')->middleware('auth');
Route::post('/carrinho/concluir', 'CarrinhoController@concluir')->name('carrinho.concluir')->middleware('auth');
Route::get('/carrinho/compras', 'CarrinhoController@compras')->name('carrinho.compras')->middleware('auth');
Route::post('/carrinho/cancelar', 'CarrinhoController@cancelar')->name('carrinho.cancelar')->middleware('auth');
Route::post('/carrinho/desconto', 'CarrinhoController@desconto')->name('carrinho.desconto')->middleware('auth');

/*ROTA DE TESTE FEATURE*/
Route::get('routeClosure', function() {
    return 'OK';
});

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;

class RoleController extends Controller
{

    public function index()
    {
        $roles = Role::all();
        return view('roles.index', compact('roles'));
    }

    public function create()
    {
        return view('roles.create');
    }

    public function store(Request $request)
    {
        $role = new Role;
        $role->name = $request->name;
        $role->save();

        return redirect()->route('role.index');
    }

    public function show($id)
    {
        //
    }

    public function edit($id)
    {
        $role = Role::where('id',$id)->first();
        return view('roles.edit', compact('role'));
    }

    public function update(Request $request, $id)
    {
        $role = Role::where('id',$id)->first();
        $role->name = $request->name;
        $role->save();

        return redirect()->route('role.index');
    }

    public function destroy($id)
    {
        $role = Role::where('id',$id)->first();
        $role->delete();

        return redirect()->route('role.index');
    }

    public function permissions($role) 
    {
        $role = Role::where('id', $role)->first();
        $permissions = Permission::all();

        foreach($permissions as $permission)
        {
            //Verificando se o perfil tem a permissão
            if($role->hasPermissionTo($permission->name)){
                $permission->can = true; //criando novo atributo como flag para setar na view
            }else {
                $permission->can = false;
            }
        }

        return view('roles.permissions', compact('role','permissions'));
    }

    public function permissionsSync(Request $request, $role) 
    {
        //Limpando o array
       $permissionsRequest = $request->except(['_token','_method']);
       //Recuperando a chave para setar na busca dos modelos
       foreach($permissionsRequest as $key => $value)
       {
           //Recuperando os medelos de objetos 
            $permissions[] = Permission::where('id',$key)->first();
       }
       //Sobrescrevendo a variavél que vem via parametro da função
       $role = Role::where('id',$role)->first();

       if(!empty($permissions))
       {
            //Método do Spatie que espera receber um array ou null
            $role->syncPermissions($permissions);
       } else {
            $role->syncPermissions(null);
       }
       //Recebendo role->id do modelo e não da string passada por parametro.
       return redirect()->route('role.permissions', ['role' => $role->id]);

    }

}

resources/views/roles/create.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">CADASTRAR PERFIL</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('role.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <form action="{{ route('role.store') }}" method="post" class="mt-4" autocomplete="off">
                            @csrf

                            <div class="form-group">
                                <label for="name">Nome do Perfil</label>
                                <input type="text" class="form-control" id="name" placeholder="Digite um perfil"
                                       name="name" value="{{ old('name') }}">
                            </div>
                             <button type="submit" class="btn btn-success"><i class="fas fa-save"></i> Cadastrar</button>
                            <a href="{{ route('role.index') }}" class="btn btn-info"><i class="fas fa-list"></i> Listar</a>
                            <a href="{{ route('/') }}" class="btn btn-danger"><i class="fas fa-ban"></i> Cancelar</a>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/roles/edit.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                   <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">EDITAR PERFIL</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('role.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <form action="{{ route('role.update', ['role' => $role->id]) }}" method="post" class="mt-4" autocomplete="off">
                            @csrf
                            @method('PUT')

                            <div class="form-group">
                                <label for="name">Nome do Perfil</label>
                                <input type="text" class="form-control" id="name" placeholder="Papéis que usuários terão no sistema"
                                       name="name" value="{{ old('name') ?? $role->name }}">
                            </div>
                            <button type="submit" class="btn btn-success">Alterar</button>
                             <a href="{{ route('role.index') }}" class="btn btn-info"><i class="fas fa-list"></i> Listar</a>
                            <a href="{{ route('/') }}" class="btn btn-danger"><i class="fas fa-ban"></i> Cancelar</a>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/roles/index.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                   <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">LISTAGEM DOS PERFIS</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('role.create') }}">&plus; Novo</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">
                        @if (session('status'))
                            <div class="alert alert-success" role="alert">
                                {{ session('status') }}
                            </div>
                        @endif

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <table class="table table-striped mt-4">
                            <thead>
                            <tr>
                                <th>#</th>
                                <th>Perfis</th>
                                <th class="th-center">Editar</th>
                                <th class="th-center">Permissões</th>
                                <th class="th-center">Deletar</th>
                            </tr>
                            </thead>
                            <tbody>

                           @foreach($roles as $role)
                                <tr>
                                    <td>{{ $role->id }}</td>
                                    <td>{{ $role->name }}</td>
                                    <td class="th-center"><a class="btn btn-link" href="{{ route('role.edit', ['role' => $role->id] ) }}">Editar</a></td>
                                       <td class="th-center">  <a class="btn btn-link" href="{{ route('role.permissions', ['role' => $role->id]) }}">Permissões</a></td>
                                       <td class="th-center">  <form action="{{ route('role.destroy', ['role' => $role->id]) }}" method="post">
                                            @csrf
                                            @method('delete')
                                            <input class="btn btn-link" type="submit" value="Remover">
                                        </form>
                                    </td>
                                </tr>
                          @endforeach

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/roles/permissions.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                     <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">CADASTRAR PERMISSÕES</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('role.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />
                    <div class="card-body">

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <h2 class="mt-4">Permissões para: {{ $role->name }}</h2>

                        <form action="{{ route('role.permissions', ['role' => $role->id]) }}" method="post" class="mt-4" autocomplete="off">
                            @csrf
                            @method('PUT')
                           @foreach($permissions as $permission)
                                <div class="custom-control custom-checkbox">
                                    <input type="checkbox" class="custom-control-input" id="{{ $permission->id }}" name="{{ $permission->id }}" {{ ($permission->can == '1' ? 'checked':'') }} />
                                    <label class="custom-control-label" for="{{ $permission->id }}">{{ $permission->name }}</label>
                                </div>
                          @endforeach
                            <button type="submit" class="btn btn-success">Sincronizar Permissões</button>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection